import processing.sound.*;
SoundFile sound;
Coin coins;
Plane plane;
Cloud clouds [];
color b1, b2, c1, c2;
int mode = 0;
int intro = 0;
int game = 1;
int end = 2;
int win = 3;
PImage img;
PImage img2;
int level = 0;
int AmClouds = 8;
int money=0;


void setup() {
  
  frameRate(20);
  size(1280, 720);
  sound = new SoundFile(this, "707.mp3");
  c1 = color(149, 187, 241);
  c2 = color(34, 81, 175);
  img = loadImage("wasd.jpg");
  img2 = loadImage("sal.png");
  coins = new Coin();
  plane = new Plane();
}

void draw() {

  setGradient(0, 0, width, height, c1, c2);

  if (mode == intro) {
    doIntro();
  } else if (mode == game) {
    doGame();
  } else if (mode == end) {
    doEnd();
  }
  else if (mode == win) {
    doWin();
  }
}


public void doIntro() {
  
  c1 = color(153, 204, 255);
  c2 = color(217, 136, 159);
  setGradient(0, 0, width, height, c1, c2);
  PFont f = createFont("Athelas-Bold", 78);
  PFont f1 = createFont("Georgia", 78);
  String introText = "Welcome to the plane game!";
  String rules = "Aim: you need to manage the plane to to avoid clouds and pick up coins to win";
  String secLine = "Press the level number on the keyborad to start the game!";
  textSize(64);
  textFont(f);
  fill(255);
  stroke(0, 35, 87);
  text(introText, width/8, height/6);
  textFont(f1);
  textSize(30);
  text(rules, 80, 200);
  textSize(25);
  text (secLine, 90, 480);
  fill(255);
  noStroke();
  rect( 170, 560, 140, 60, 16); //level 1
  rect( 420, 560, 140, 60, 16); //level 2
  rect( 680, 560, 140, 60, 16); //level 3
  fill(0, 35, 87);
  text("level 1", 120, 567);
  text("level 2", 370, 567);
  text("level 3", 630, 567);
  fill(255);
  text("easy", 120, 630);
   text("pick up 3 coins", 120, 670);
  text("medium", 370, 630);
   text("pick up 5 coins", 370, 670);
  text("hard", 630, 630);
   text("pick up 7 coins", 630, 670);
  fill(0, 35, 87);
  textSize(25);
  text("hint: use this letters\n to manage the plane", 920, 450);
  image(img, 950, 510, 160, 160);
  rectMode(CENTER);
  fill(0, 35, 87);
  int posX=400;
  int posY=340;
  rect(posX+20, posY-1, 135, 70);
  ellipse(posX-31, posY-10, 120, 90);
  ellipse(posX+90, posY-7, 90, 80);
  ellipse(posX+60, posY-17, 90, 100);
  ellipse(posX, posY-50, 80, 70);
  fill(255);
  noStroke();
  int posPlaneX = 755;
  int posPlaneY = 330;
  triangle(posPlaneX-70, posPlaneY, posPlaneX+30, posPlaneY-70, posPlaneX-20, posPlaneY);
  triangle(posPlaneX-70, posPlaneY, posPlaneX+30, posPlaneY+70, posPlaneX-20, posPlaneY);
  triangle(posPlaneX-70, posPlaneY, posPlaneX+30, posPlaneY+70, posPlaneX-20, posPlaneY);
  triangle(posPlaneX+45, posPlaneY, posPlaneX+95, posPlaneY-50, posPlaneX+75, posPlaneY);
  triangle(posPlaneX+45, posPlaneY, posPlaneX+95, posPlaneY+50, posPlaneX+75, posPlaneY);
  ellipse (posPlaneX, posPlaneY, 200, 30);
  int posXC = 590;
  int posYC = 260;
     fill(255, 229, 15);
    stroke(255, 190, 0);
    ellipse(posXC, posYC, 40, 40);
    fill(255, 190, 0);
    ellipse (posXC, posYC, 25, 25);

  if (key == '1') {
    mode = game;
    level = 1;
    AmClouds = 5;
  }
  if (key == '2') {
    mode = game;
    level = 2;
    AmClouds = 7;
  }
  if (key == '3') {
    mode = game;
    level = 3;
    AmClouds = 9;
  }
  clouds = new Cloud[AmClouds];
  for (int i=0; i<clouds.length; i++) {
    clouds[i] = new Cloud();
  }
}

public void doGame() {
  c1 = color(255, 229, 250);
  c2 = color (51, 102, 204);
  setGradient(0, 0, width, height, c1, c2);

  if (!sound.isPlaying()) {
    sound.play();
  }
 
  plane.runPlane(); 
  coins.runCoin();
  for (int i = 0; i<clouds.length; i++) {
    clouds[i].run();

    //fill(255,0,0);
    //ellipse(plane.posPlaneX, plane.posPlaneY, 130, 130); // plane citcle
    //ellipse(clouds[i].posX+90, clouds[i].posY-7, 70, 70);//little edge circle for cloud
    //ellipse(clouds[i].posX, clouds[i].posY-14, 110, 110);//big cloud circle

    float d1 = dist(clouds[i].posX+90, clouds[i].posY-7, plane.posPlaneX, plane.posPlaneY); //distance between clouds circles  and plane
    float d2 = dist(clouds[i].posX, clouds[i].posY-14, plane.posPlaneX, plane.posPlaneY);
    if ( d1<=105 || d2 <= 125) { 
       mode = end;
    }
  }
  
    fill(255, 229, 15);
    stroke(1, 1, 1);
    rect( 70, 43, 110, 40);
    fill(1, 1, 1);
    text("score:", 30 , 50);
   
  
    float distCoin= dist( coins.posXC, coins.posYC, plane.posPlaneX, plane.posPlaneY); 
    if (distCoin < 85){
      coins.posYC = -20;
      coins.posXC = random(width);
      money+=1;
    }
    text (money, 100, 50);
    
    if (level ==1 && money == 3 ) {
       mode = win;
    }
    if ( level == 2 && money == 5) {
       mode = win;
    }   
    if ( level == 2 && money == 7) {
       mode = win;
    }    
  
}

public void doEnd() {
  
  c1 = color(255);
  c2 = color(2, 1, 15);
  setGradient(0, 0, width, height, c1, c2);
  PFont f = createFont("Athelas-Bold", 78);
  textSize(64);
  textFont(f);
  fill(c2);
  text("you crashed the plane!", width/6, height/6);
  fill(255);
  noStroke();
  int posPlaneX = width/2-50;
  int posPlaneY = 330;
  triangle(posPlaneX-70, posPlaneY, posPlaneX+30, posPlaneY-70, posPlaneX-20, posPlaneY);
  triangle(posPlaneX-70, posPlaneY, posPlaneX+30, posPlaneY+70, posPlaneX-20, posPlaneY);
  triangle(posPlaneX-70, posPlaneY, posPlaneX+30, posPlaneY+70, posPlaneX-20, posPlaneY);
  triangle(posPlaneX+45, posPlaneY, posPlaneX+95, posPlaneY-50, posPlaneX+75, posPlaneY);
  triangle(posPlaneX+45, posPlaneY, posPlaneX+95, posPlaneY+50, posPlaneX+75, posPlaneY);
  ellipse (posPlaneX, posPlaneY, 200, 30);
  textSize(40);
  text("press space to play again", 380, 600);

  if (key == ' ') {
    mode = 0;
    plane.posPlaneX = 1115;
    plane.posPlaneY = 300;
    coins.posXC = 0;
    coins.posYC = 0;
    money=0;
    c2=0;
  }
}

public void doWin() {
  c2 = color(217, 136, 159);
  setGradient(0, 0, width, height, c1, c2);
  
  fill(33,16,80);
  textSize(64);
  text("congrats, you win!", 380, height/6);
  textSize(30);
  text("press space to play again", 480, 600);
  image(img2, width/4, height/4);

  if (key == ' ') {
    mode = 0;
    money = 0;
    plane.posPlaneX = 1115;
    plane.posPlaneY = 300;
    c2=0;
    coins.posXC = 0;
    coins.posYC = 0;
  
  }
  
}


void setGradient(int x, int y, float w, float h, color c1, color c2 ) {

  noFill();
  for (int i = y; i <= y+h; i++) {
    float inter = map(i, y, y+h, 0, 1);
    color c = lerpColor(c1, c2, inter);
    stroke(c);
    line(x, i, x+w, i);
  }
}
